var WebCrawler = React.createClass({

    mixins: [Reflux.connect(store)],

    componentDidMount: function(){
        var model = {
            pages: [
                {
                    hashed_id: '1',
                    url: 'https://tw.news.yahoo.com/034800554.html',
                    text: '台北燈會即將於春節後盛大登場，照以往慣例，主燈都會提前揭曉，根據台北市民政局所公布的圖片，今年的主燈取名為「福祿猴」，外觀為葫蘆造型，配上彩繪風的猴臉，是由國際知名多媒體藝術大師林書民所操刀製作，雖然意象上有中華傳統的「多子多孫好福氣」寓意，但這個造型卻著實嚇壞了網友，還有人吐槽說「沒看過這麼醜的主燈」、「這是沒年終的設計師搞嗎？」'
                },
                {
                    hashed_id: '2',
                    url: 'https://tw.news.yahoo.com/2-043021446.html',
                    text: '自由之家（Freedom House）今天公布年度報告（Freedom in the World 2016），台灣再度名列自由國家，在兩項評比指標的「政治權利」獲得最自由的第一級評價，「公民自由」則獲得次高的2級。'
                },
                {
                    hashed_id: '3',
                    url: 'https://tw.news.yahoo.com/035200511.html',
                    text: '郝龍斌坦言，他心中認為最適合人選是吳敦義，因為吳敦義做過黨務工作，行政歷練豐富，也在南部做過首長，這次南投立委選舉成功，顯示吳對中南部狀況非常了解，吳敦義決定不選，他感到遺憾。'
                },
            ]
        };

        //actions.loadModel(model);
    },

    aStyles: {
        display: 'block',
        //backgroundColor: 'red',
        width: '480px',
        overflow: 'auto'
    },

    generateRows: function(){
        var rows = [];
        var rows = this.state.crawlerModel.pages.map(function(page){

            if (!page.visited) {
                return;
            }

            var result = WordMan.parse(page.text);
            var counts = {
                totalChars: result.total_chars,
                englishWords: result.english_words,
                chineseChars: result.chinese_chars,
                chinesePunctuations: result.chinese_punctuations,
                englishChars: result.english_chars,
                englishPunctuations: result.english_punctuations,
                arabicNumerals: result.arabic_numerals,
                spaces: result.spaces,
                others: result.others
            };
            var sum = 0;

            for(var i in this.state.filters){
                if (i=='englishWords') continue;
                if (this.state.filters[i]) sum += counts[i]
            }

            var row =
            <tr className={page.included ? '' : 'not-included'} key={page.hashed_id}>
                <td><a href={page.url} target='_blank'>{page.url}</a></td>
                <td>{result.english_words}</td>
                <td>{sum}</td>
                <td><ViewPage text={page.text} /></td>
                <td><input type='checkbox' checked={page.included} onClick={actions.togglePage.bind(this, page.hashed_id)} /></td>
            </tr>
            return row;
        }.bind(this));
        return rows;
    },

    startCrawl: function(){
        actions.getLinks(this.refs.url.getDOMNode().value);
    },

    handleKeyDown: function(e){
        if(e.keyCode == 13){
            actions.getLinks(this.refs.url.getDOMNode().value);
        }
    },

    inputStyles: {
        width: '480px',
        padding: '12px',
        "font-size": '16px',
        margin: '0px 12px 0px 0px',

    },

    render: function(){
        var rows = this.generateRows();
        var table;
        if(this.state.status == 'idle' || this.state.status == 'idle'){

        }else{
            table =
                    <table>
                        <tr>
                            <th>{trans('url')}</th>
                            <th>{trans('en-count')}</th>
                            <th>{trans('cn-count')}</th>
                            <th>{trans('text')}</th>
                            <th>{trans('include')}</th>
                        </tr>
                        {rows}
                    </table>
        }
        return(
            <div>
                <div className="row">
                    <input style={this.inputStyles} ref='url' type='text' placeholder='Enter url here...' onKeyDown={this.handleKeyDown} />
                    <button className="large btn-green" onClick={this.startCrawl}>{trans('analyse')}</button>
                </div>
                <div className="row">
                    {trans('current-limit')}
                </div>
                <div id="status" className="row">
                    <Status />
                </div>
                <div>
                    {table}
                </div>

            </div>
        );
    }
});
